//+------------------------------------------------------------------+
//|                                                  TradeSystem.mq4 |
//|                                 Copyright  2007   |
//|                                                los@we.kherson.ua |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007,   "
#property link      "mailto: los@we.kherson.ua"

#include <Traling.mqh>
#include <stderror.mqh>
#include <stdlib.mqh>

double MinLot=0.1; //  ,       

void ProcessAvgLim(int SignalID, int SysID, color ClrBuy, color ClrSell)
{
//	double lots = AccountFreeMargin()*0.1*0.00001; //  = 100 ..  100000 .. ( 1/1000)
	double lots = AccountFreeMargin()*0.1*0.00001; // 
	lots = NormalizeDouble(lots, LotDigit); //    
	if (MinLot>lots) lots = MinLot;//     
	
	double price = 0.0;
	int total, i, cbuy, csell, Signal, pos;
	
//----    
	Signal = CheckSignal(true, SignalID);
	if (Signal == -1) return; //        
	
//-----   
	if(Signal == OP_BUY)
	{
		cbuy = CountAllOrders(OP_BUY, SysID); 
		if (cbuy<=0) // ,  
		{	//   LIMIT
			total = CreatTicketArray(OP_BUYLIMIT, SysID); for (i=1; i<=total; i++) OrderDelete(Ticket[i], Green);
			// 
			OrderSend(Symbol(), OP_BUY, lots, Ask, 3, Ask-SysPar[SysID][_SL]*Point, Ask+SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrBuy);
		}
		else //  
		{	//    	
			total = CreatTicketArray(OP_BUY, SysID); OrderSelect(Ticket[1], SELECT_BY_TICKET); price=OrderOpenPrice(); pos = 1;
			for (i=2; i<=total; i++)
			{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	if (OrderOpenPrice()>price)	{	price=OrderOpenPrice(); pos = i; }	}
			OrderSelect(Ticket[pos], SELECT_BY_TICKET);  lots = OrderLots(); 	lots = NormalizeDouble(lots, LotDigit);
			if (OrderOpenPrice()<Ask-100*Point)
				OrderSend(Symbol(), OP_BUY, lots, Ask, 2, Ask-SysPar[SysID][_SL]*Point, Ask+SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrBuy);
		}
	}
//-----    
	if(Signal == OP_SELL)
	{
		csell = CountAllOrders(OP_SELL, SysID); 
		if (csell<=0)	// ,  
		{
			total = CreatTicketArray(OP_SELLLIMIT, SysID);	for (i=1; i<=total; i++)	OrderDelete(Ticket[i], Red);
			OrderSend(Symbol(), OP_SELL, lots, Bid, 3, Bid+SysPar[SysID][_SL]*Point, Bid-SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrSell);
		}
		else //  
		{	//    	
			total = CreatTicketArray(OP_SELL, SysID);	OrderSelect(Ticket[1], SELECT_BY_TICKET); price=OrderOpenPrice(); pos = 1;
			for (i=2; i<=total; i++)
			{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	if (OrderOpenPrice()<price)	{	price=OrderOpenPrice(); pos = i; }	}
			OrderSelect(Ticket[pos], SELECT_BY_TICKET);  lots = OrderLots(); 	lots = NormalizeDouble(lots, LotDigit);
			if (OrderOpenPrice()>Bid+100*Point)
				OrderSend(Symbol(), OP_SELL, lots, Bid, 2, Bid+SysPar[SysID][_SL]*Point, Bid-SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrBuy);
		}
	}
}

void ProcessAvgStop(int SignalID, int SysID, color ClrBuy, color ClrSell)
{
//	double lots = AccountFreeMargin()*0.1*0.00001; //  = 100 ..  100000 .. ( 1/1000)
	double lots = AccountFreeMargin()*0.1*0.00001; // 
	lots = NormalizeDouble(lots, LotDigit); //    
	if (MinLot>lots) lots = MinLot;//      
//	lots = MinLot;
	
	double price = 0.0;
	int total, i, Signal, pos;

//----    
	Signal = CheckSignal(true, SignalID);
//	if (Signal == -1) return; //        
//	if (Signal == OP_BUY)
	{
		total = CreatTicketArray(OP_BUY, SysID);
		if (total<=0)	//----  ,  
			OrderSend(Symbol(), OP_BUY, lots, Ask, 2, Ask-SysPar[SysID][_SL]*Point, Ask+SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrBuy);
		else //  
		{	//    	
			OrderSelect(Ticket[1], SELECT_BY_TICKET); price=OrderOpenPrice(); pos = 1;
			for (i=2; i<=total; i++)
			{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	if (OrderOpenPrice()>price)	{	price=OrderOpenPrice(); pos = i; }	}
			OrderSelect(Ticket[pos], SELECT_BY_TICKET);  lots = OrderLots(); 	lots = NormalizeDouble(lots, LotDigit);
			if (OrderOpenPrice()<Ask-100*Point)
				OrderSend(Symbol(), OP_BUY, lots, Ask, 2, Ask-SysPar[SysID][_SL]*Point, Ask+SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrBuy);
		}
	}

//-----    
//	if(Signal == OP_SELL)
	{
		total = CreatTicketArray(OP_SELL, SysID); 
		if (total<=0)	// ,  
			OrderSend(Symbol(), OP_SELL, lots, Bid, 2, Bid+SysPar[SysID][_SL]*Point, Bid-SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrSell);
		else //  
		{ //    	
			OrderSelect(Ticket[1], SELECT_BY_TICKET); price=OrderOpenPrice(); pos = 1;
			for (i=2; i<=total; i++)
			{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	if (OrderOpenPrice()<price)	{	price=OrderOpenPrice(); pos = i; }	}
			OrderSelect(Ticket[pos], SELECT_BY_TICKET);  lots = OrderLots(); 	lots = NormalizeDouble(lots, LotDigit);
			if (OrderOpenPrice()>Bid+100*Point)
				OrderSend(Symbol(), OP_SELL, lots, Bid, 2, Bid+SysPar[SysID][_SL]*Point, Bid-SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrBuy);
		}
	}
}

void ProcessTurn(int SignalID, int SysID, color ClrBuy, color ClrSell)
{
//	double lots = AccountFreeMargin()*0.1*0.00001; //  = 100 ..  100000 .. ( 1/1000)
	double lots = AccountFreeMargin()*0.1*0.00001; // 
	lots = NormalizeDouble(lots, LotDigit); //    
	if (MinLot>lots) lots = MinLot;//     
	
	int ticket, total, i, cbuy, csell, Signal;
	
	Signal = CheckSignal(false, SignalID);//----    
   if(Signal != -1)	CloseAllOrders(Signal, SysID, ClrBuy, ClrSell);

	cbuy = CountAllOrders(OP_BUY, SysID); csell = CountAllOrders(OP_SELL, SysID); 
	//----  STOP
	if (cbuy<=0) {	total = CreatTicketArray(OP_SELLSTOP, SysID); for (i=1; i<=total; i++) OrderDelete(Ticket[i], ClrSell);}
	if (csell<=0) { total = CreatTicketArray(OP_BUYSTOP, SysID); for (i=1; i<=total; i++) OrderDelete(Ticket[i], ClrBuy);}

	Signal = CheckSignal(true, SignalID);//----    
	if (Signal == -1) return; //        

	if(Signal==OP_BUY)//-----   
	{
		if (cbuy>0)	return; //----      ,    
		//----    STOP
		total = CreatTicketArray(OP_SELLSTOP, SysID); for (i=1; i<=total; i++) OrderDelete(Ticket[i], Red);
		OrderSend(Symbol(), OP_BUY, lots, Ask, 3, Ask-SysPar[SysID][_SL]*Point, Ask+SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrBuy);
		OrderSend(Symbol(), OP_SELLSTOP, lots, Ask-SysPar[SysID][_SL]*Point, 3, Ask, Ask-2*SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrSell);
		return; 
	}
	if(Signal==OP_SELL)//-----   
	{
		if (csell>0)	return; //----      ,    
		total = CreatTicketArray(OP_BUYSTOP, SysID); for (i=1; i<=total; i++) OrderDelete(Ticket[i], Red);
		OrderSend(Symbol(), OP_SELL, lots, Bid, 3, Bid+SysPar[SysID][_SL]*Point, Bid-SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrSell);
		OrderSend(Symbol(), OP_BUYSTOP, lots, Bid+SysPar[SysID][_SL]*Point, 3, Bid, Bid+2*SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrSell);
		return;
	}
//----
}

void ProcessSimple(int SignalID, int SysID, color ClrBuy, color ClrSell)
{
//	double lots = AccountFreeMargin()*0.1*0.00001; //  = 100 ..  100000 .. ( 1/1000)
	double lots = AccountFreeMargin()*0.1*0.00001; // 
	lots = NormalizeDouble(lots, LotDigit); //    
	if (MinLot>lots) lots = MinLot;//     
	
	int ticket, total, i, cbuy, csell, Signal;
	
//----    
	Signal = CheckSignal(false, SignalID);
   if(Signal != -1)	TryCloseAllOrders(Signal, SysID, ClrBuy, ClrSell);

//----    
	cbuy = CountAllOrders(OP_BUY, SysID); csell = CountAllOrders(OP_SELL, SysID); 

	Signal = CheckSignal(true, SignalID);
	if (Signal == -1) return; //        
	
//-----   
   if(Signal == OP_BUY)
	{
		if (cbuy>0)	return; //----      ,    
		//----    BUY
		ticket = OrderSend(Symbol(), OP_BUY, lots, Ask, 3, Ask-SysPar[SysID][_SL]*Point, Ask+SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrBuy);
		if (ticket==-1) { i=GetLastError();	Print("error(",i,"): ",ErrorDescription(i));}
		return; 
	}

//-----   
	if(Signal == OP_SELL)
	{
		if (csell>0)	return; //----      ,    
		ticket = OrderSend(Symbol(), OP_SELL, lots, Bid, 3, Bid+SysPar[SysID][_SL]*Point, Bid-SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrSell);
		if (ticket==-1) { i=GetLastError();	Print("error(",i,"): ",ErrorDescription(i));}
		return;
	}
//----
}

void ProcessMultiOpen(int SignalID, int SysID, color ClrBuy, color ClrSell)
{
//	double lots = AccountFreeMargin()*0.1*0.00001; //  = 100 ..  100000 .. ( 1/1000)
	double lots = AccountFreeMargin()*0.1*0.00001; // 
	lots = NormalizeDouble(lots, LotDigit); //    
	if (MinLot>lots) lots = MinLot;//     
	
	int ticket, total, i, cbuy, csell, Signal;
//----      
	cbuy = CreatTicketArray(OP_BUY, SysID); csell = CreatTicketArray(OP_SELL, SysID); 
	
//----    
	Signal = CheckSignal(true, SignalID);
	if (Signal == -1) return; //        
	
//-----   
   if(Signal == OP_BUY)
		{
			if (cbuy>0)	//  
				for (i=1; i<=cbuy; i++)//     ,    
				{	OrderSelect(Ticket[i], SELECT_BY_TICKET); if (OrderOpenTime()>=Time[0]) return; } 
			//----    BUY
			ticket = OrderSend(Symbol(), OP_BUY, lots, Ask, 3, Ask-3000*Point, Ask+SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrBuy);
			if (ticket==-1) { i=GetLastError();	Print("error(",i,"): ",ErrorDescription(i));}
			return; 
		}
//-----    
	if(Signal == OP_SELL)
		{
			if (csell>0)	 for (i=1; i<=csell; i++) {	OrderSelect(Ticket[i], SELECT_BY_TICKET); if (OrderOpenTime()>=Time[0]) return; } 
			ticket = OrderSend(Symbol(), OP_SELL, lots, Bid, 3, Bid+3000*Point, Bid-SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrSell);
			if (ticket==-1) { i=GetLastError();	Print("error(",i,"): ",ErrorDescription(i));}
			return;
     }
//----
}
int init()  
{   
	InitSystemParam(); 
	
	SysParName[BLACKSYS] = "BLACKSYS";
	SysPar[BLACKSYS][_TP] = 1000.0;//  ,      
	SysPar[BLACKSYS][_NullTP] = 20.0;//  ,      
	SysPar[BLACKSYS][_TS] = 50.0; //    
	SysPar[BLACKSYS][_NullSL] = 20.0;// ,         
	SysPar[BLACKSYS][_SL] = 70;//   ,   BLACKSYS

	SysParName[BLACKSYS+1] = "BLACKSYS+1";
	SysPar[BLACKSYS+1][_NullTP] = 20.0;//  ,      
	SysPar[BLACKSYS+1][_TS] = 50.0; //    
	SysPar[BLACKSYS+1][_NullSL] = 20.0;// ,         
	SysPar[BLACKSYS+1][_SL] = 8000;//   ,   BLACKSYS

	SysParName[ENVELOP] = "ENVELOP";
	SysPar[ENVELOP][_TP] = 2000.0;//  
	SysPar[ENVELOP][_NullTP] = 20.0;//  ,      
	SysPar[ENVELOP][_TS] = 40.0; //    
	SysPar[ENVELOP][_NullSL] = 20.0;// ,         
	SysPar[ENVELOP][_SL] = 70;//   ,   
	SysPar[ENVELOP][_dSL] = 35;//         

	SysParName[CSPLINE] = "CSPLINE";
	SysPar[CSPLINE][_TP] = 180.0;//   
	SysPar[CSPLINE][_NullTP] = 30.0;//  ,      
	SysPar[CSPLINE][_TS] = 50.0; //    
	SysPar[CSPLINE][_NullSL] = 70.0;// ,         
	SysPar[CSPLINE][_SL] = 45;//

	SysParName[MACROSS3] = "MACROSS3";
	SysPar[MACROSS3][_TP] = 200.0;//   
	SysPar[MACROSS3][_NullTP] = 30.0;//  ,      
	SysPar[MACROSS3][_TS] = 50.0; //    
	SysPar[MACROSS3][_NullSL] = 70.0;// ,         
	SysPar[MACROSS3][_SL] = 45;//

	SysParName[KRIVETKA] = "KRIVETKA";
	SysPar[KRIVETKA][_TP] = 1000.0;//   
	SysPar[KRIVETKA][_NullTP] = 100.0;//  ,      
	SysPar[KRIVETKA][_TS] = 150.0; //    
	SysPar[KRIVETKA][_NullSL] = 210.0;// ,         
	SysPar[KRIVETKA][_SL] = 450;//
	SysPar[KRIVETKA][_dSL] = 50;//   ,   

	SysParName[BORCHAN] = "BORCHAN";
	SysPar[BORCHAN][_TP] = 1000.0;//   
	SysPar[BORCHAN][_NullTP] = 50.0;//  ,      
	SysPar[BORCHAN][_TS] = 50.0; //    
	SysPar[BORCHAN][_NullSL] = 210.0;// ,         
	SysPar[BORCHAN][_SL] = 57;//

	SysParName[FORCE] = "FORCE";
	SysPar[FORCE][_TP] = 1000.0;//   
	SysPar[FORCE][_NullTP] = 40.0;//  ,      
	SysPar[FORCE][_NullTP2] = 20.0;//  ,      
	SysPar[FORCE][_TS] = 50.0; //    
	SysPar[FORCE][_NullSL] = 50.0;// ,         
	SysPar[FORCE][_SL] = 50;//
	SysPar[FORCE][_dSL] = 40;//   ,   

	SysParName[GRID] = "GRID";
	SysPar[GRID][_TP] = 2000.0;//   
	SysPar[GRID][_NullTP] = 50.0;//  ,      
	SysPar[GRID][_NullTP2] = 15.0;//  ,       
	SysPar[GRID][_TS] = 40.0; //    
	SysPar[GRID][_NullSL] = 100.0;// ,         
	SysPar[GRID][_SL] = 2000;//

	SysParName[BUYFOREVE] = "BUYFOREVE";
	SysPar[BUYFOREVE][_TP] = 2000.0;//   
	SysPar[BUYFOREVE][_NullTP] = 25.0;//  ,      
	SysPar[BUYFOREVE][_NullTP2] = 15.0;//  ,       
	SysPar[BUYFOREVE][_TS] = 50.0; //    
	SysPar[BUYFOREVE][_NullSL] = 60.0;// ,         
	SysPar[BUYFOREVE][_SL] = 2000;//

	SysParName[SELLFOREVE] = "SELLFOREVE";
	SysPar[SELLFOREVE][_TP] = 2000.0;//   
	SysPar[SELLFOREVE][_NullTP] = 25.0;//  ,      
	SysPar[SELLFOREVE][_NullTP2] = 15.0;//  ,       
	SysPar[SELLFOREVE][_TS] = 50.0; //    
	SysPar[SELLFOREVE][_NullSL] = 60.0;// ,         
	SysPar[SELLFOREVE][_SL] = 2000;//
//	HideTestIndicators(true);
	
	return(0);  
}
int deinit()  {  	HideTestIndicators(false); return(0);  }

void start()
{
//----     
//   if(IsTradeAllowed()==false) {Comment("!!!! !!!!!"); return; }

	ProcessAvgLim(BUYFOREVE, BUYFOREVE, Black, Plum);	TrailingAvgLim(BUYFOREVE, Black, Plum);
	ProcessAvgLim(SELLFOREVE,SELLFOREVE, SkyBlue, Wheat);	TrailingAvgLim(SELLFOREVE, SkyBlue, Wheat);

//	ProcessAvgStop(GRID, GRID, Black, Plum);	TrailingAvgStop(GRID, Black, Plum);

/* */
//	ProcessAvgLim(FORCE, FORCE, Green, Red);	TrailingAvgLim(FORCE, Green, Red);
//	ProcessAvgLim(ENVELOP, ENVELOP, Green, Red);	TrailingAvgLim(ENVELOP, Green, Red);
//	ProcessSimple(BLACKSYS, BLACKSYS, Green, Red);	TrailingSimple(BLACKSYS, Green, Red);//  4
//	ProcessSimple(MACROSS3, MACROSS3, Green, Red);	TrailingSimple(MACROSS3, Green, Red);//

/**/
//	ProcessTurn(BORCHAN, BORCHAN, Green, Red);	TrailingSimple(BORCHAN, Green, Red);
//	ProcessSimple(KRIVETKA, KRIVETKA, Green, Red);	TrailingSimple(KRIVETKA, Green, Red);//
//	ProcessSimple(CSPLINE, CSPLINE, Green, Red);	TrailingSimple(CSPLINE, Green, Red);//
//	ProcessSimple(MACD, MACD, Black, Plum);	TrailingSimple(MACD, Black, Plum);
//	ProcessAvgLim(BLACKSYS, BLACKSYS+1, Green, Red);	TrailingAvgLim(BLACKSYS+1, Green, Red); //
}
//+------------------------------------------------------------------+